require 'test_helper'

class UsersControllerTest < ActionController::TestCase
  setup do
    @user = users(:two)
  end

  test "should get index" do
    get :index, nil, user: users(:me).id
    assert_response :success
    assert_not_nil assigns(:users)
  end

  test "should get new" do
    get :new, nil, user:users(:me).id
    assert_response :success
  end

  test "should create user" do
    assert_difference('User.count') do
      post :create, {user: { email: 'valakimas@mail.bme.hu', family_name: 'Elek', first_name: 'Teszt', last_login: @user.last_login, password: 'titok', password_confirmation: 'titok', username: 'tesztelek' }}, {user: users(:me).id}
    end

    assert_redirected_to user_path(assigns(:user))
  end

  test "should show user" do
    get :show, {id: @user.id}, {user: @user.id} 
    assert_response :success
  end

  test "should get edit" do
    get :edit, {id: @user.id}, {user: @user.id} 
    assert_response :success
  end

  test "should update user" do
    patch :update, {id: @user.id, user: { email: @user.email, family_name: @user.family_name, first_name: @user.first_name, last_login: @user.last_login, password: @user.password, password_confirmation: @user.password, username: @user.username+'_' }}, {user: @user.id}
    assert_redirected_to user_path(assigns(:user))
  end

  test "should destroy user" do
    assert_difference('User.count', -1) do
      delete :destroy, {id: @user.id}, {user: users(:me).id}
    end

    assert_redirected_to users_path
  end
end
